/**
 * \file LandmarkBand.hpp
 *
 * Header file that declares landmark band specific functions 
 *
 * \author Redouane Boumghar, Hung Cao
 *
 * \ingroup lgl
 *
 **/

#ifndef LGL_LANDMARKBAND_HPP
#define LGL_LANDMARKBAND_HPP

#include <iostream>

#include <gdal_priv.h>

#include <lgl/Raster.hpp>
#include <lgl/RasterBand.hpp>

namespace jafar {
  namespace lgl {
		class GDLandmarkBand : public  GDRasterBand<double> { /*{{{*/ 
			
		public:
			
			GDLandmarkBand(GDALDataset* _dataset, GDALRasterBand *_band);
			
			~GDLandmarkBand();
			
			// abstract methods from RasterBand
			bool isHomogeneous(const RasterRect& rect) const;			

		private:

		protected:
			
		}; /*}}}*/
		
  }
}

#endif
