/**
 * \file QuadtreeMatrix.hpp
 *
 * Header file for the quadtree matrix declaration 
 *
 * \author Redouane Boumghar, Hung Cao
 *
 * \ingroup lgl
 *
 **/

#ifndef LGL_QUADTREEMATRIX_HPP
#define LGL_QUADTREEMATRIX_HPP

#include <iostream>

#include <list>
#include <vector>

#include <lgl/FlexGrid.hpp>

namespace jafar {
	namespace lgl {
		/** Class for quadtree utility of the lgl module.
		 *
		 * @ingroup lgl
		 */
		class QuadMat { /*{{{*/ 
			public:
				/** The grid data, the cell value is a double */
				typedef FlexGrid<bool> mat_t;
				mat_t mat;
				QuadMat(ssize_t xsize, ssize_t ysize);
				~QuadMat();
				ssize_t nbLeaves();
		};
	}  // namespace lgl
} // namespace jafar

#endif /* LGL_QUADTREEMATRIX_HPP */
