/* $Id$ */

// test suite specific includes
#include "lgl/GeoData.hpp"
#include "lgl/Raster.hpp"

namespace jafar {

  namespace lgl {

    /* 
     * class GeoData test suite 
     */

    class test_GeoData {
		
	public:
		
		test_GeoData(std::string filename) {

			GeoData *geodata = new GeoData(filename);
			double value;
			double tmpv;
			value = geodata->getBand(GEODATA_TFLAT_BAND)->getValue(RasterPoint(64,64));
			std::cout << value << std::endl;

			RasterRect r1(10,10,10,10);
			RasterRect r2(5,15,10,6);
			RasterRect result;
			std::cout << r1.intersects(r2,result) <<  ":" << r2.intersects(r1,result) << std::endl;

			int x = 0;
			int y = 0;

			int xroot=0;
			int yroot=0;
			int xsize=64;
			int ysize=64;

			// unsigned char* data = ((GDTravBand *)geodata->getBand(GEODATA_TFLAT_BAND))->getBlock(RasterRect(xroot,yroot,xsize,ysize));

			//unsigned char* data = (unsigned char*)geodata->getBand(GEODATA_TFLAT_BAND)->getBlock(RasterRect(xroot,yroot,xsize,ysize),GDT_Byte);
		  
			for (int i=0; i < (xsize*ysize); i++) {

				x = xroot+(i- ((i/xsize)*xsize));
				y = yroot+(i/xsize);

				if ( geodata->getBand(GEODATA_TFLAT_BAND)->getValue( x, y, &value) ) 
				{
					tmpv = geodata->getBand(GEODATA_TFLAT_BAND)->getValue(RasterPoint(x, y));
					if ( value != tmpv )
					{
						std::cout << "Diff  "<< value << ":" << tmpv << " at (" << x << ", " << y << ")" << std::endl;
					} else {
						std::cout << "OK    "<< value << ":" << tmpv << " at (" << x << ", " << y << ")" << std::endl;
					}
				} else {
					std::cout << "ERROR could not read from the GDAL Dataset" << std::endl;
				}
			}

			float mean = geodata->getBand(GEODATA_TFLAT_BAND)->mean(RasterRect(xroot,yroot,xsize,ysize));
			std::cout << "Mean = " << mean << std::endl;

			float sd = geodata->getBand(GEODATA_TFLAT_BAND)->sd(RasterRect(xroot,yroot,xsize,ysize));
			std::cout << "SD = " << sd << std::endl;

		}

    };
  } // namespace lgl

} // namespace jafar
